# short-private-properties

This plugin find in ES6 Classes all methods or properties with start `_` and replace them with a short name.

[![npm](https://img.shields.io/npm/v/babel-plugin-short-private-properties.svg)](https://www.npmjs.com/package/babel-plugin-short-private-properties)
[![AppVeyor](https://img.shields.io/appveyor/ci/retyui/babel-plugin-short-private-properties.svg?label=win)](https://ci.appveyor.com/project/retyui/babel-plugin-short-private-properties)
[![Travis](https://img.shields.io/travis/retyui/babel-plugin-short-private-properties.svg?label=unix)](https://travis-ci.org/retyui/babel-plugin-short-private-properties)

## Install

```bash
yarn add -D babel-plugin-short-private-properties
# or npm i -D babel-plugin-short-private-properties
```

## Input:

```js
class A {
  constructor() {
    this._veryLondProppertyNameA = "Test class A";
    this._veryLondProppertyNameA2 = "Write A";
  }
  _getAProperty() {
    console.log(this._veryLondProppertyNameA);
  }
}

class B extends A {
  constructor() {
    super();
    this._veryLondProppertyNameA2 = "Overwrite B";
    this._veryLondProppertyNameB = "Test class B";
  }
  getResult() {
    this._getAProperty();
    console.log(this._veryLondProppertyNameB);
    console.log(this._veryLondProppertyNameA2);
  }
}

new B().getResult();
// Test class A
// Test class B
// Overwrite B
```

## Output:

```js
class A {
  constructor() {
    this._b = "Test class A";
    this._c = "Write A";
  }
  _d() {
    console.log(this._b);
  }
}

class B extends A {
  constructor() {
    super();
    this._c = "Overwrite B";
    this._e = "Test class B";
  }
  getResult() {
    this._d();
    console.log(this._e);
    console.log(this._c);
  }
}

new B().getResult();
// Test class A
// Test class B
// Overwrite B
```

# Usage

### Via .babelrc (Recommended)

```json
{
  "plugins": ["babel-plugin-short-private-properties"]
}
```

### Via CLI

```sh
$ babel --plugins babel-plugin-short-private-properties script.js
```

### Via Node API

```javascript
require("babel-core").transform("code", {
  plugins: ["babel-plugin-short-private-properties"]
});
```
