var _require = require("./MapHash.js"),
	MapHash = _require.MapHash;

var AllClassMap = new Map();
var namesMap = new MapHash(AllClassMap);

var filterParent = function filterParent(parentType, key) {
	return (
		(parentType === "ClassMethod" && key === "key") ||
		(parentType === "MemberExpression" && key === "property")
	);
};

var visitorProps = {
	Identifier: function Identifier(path) {
		var identifierName = path.node.name;

		if (
			identifierName.startsWith("_") === true &&
			filterParent(path.parent.type, path.key) === true
		) {
			var _path$findParent = path.findParent(function(path) {
					return path.isClassDeclaration();
				}),
				classNode = _path$findParent.node;

			if (classNode) {
				path.node.name = namesMap.getName(identifierName, classNode);
			}
		}
	}
};

module.exports = function(babel) {
	namesMap.clear();
	AllClassMap.clear();
	return {
		visitor: {
			ClassDeclaration: function ClassDeclaration(path) {
				AllClassMap.set(path.node.id.name, path.node);
				path.traverse(visitorProps);
			}
		}
	};
};
